package Relationen is

   type Relation is private;
   
   GrundmengenVerschieden : exception;
   
   ElementNichtInGrundmenge : exception;

   -- Erstellt eine leere Relation auf der Grundmenge [von .. bis].
   function LeerRelationAuf (von, bis : Integer) return Relation; 

   -- Trgt ein neues Paar (a,b) in die Relation R ein. 
   procedure Eintrag (a,b : Integer; R : in out Relation); 

   -- Lscht ein Paar (a,b) aus der Relation R.
   procedure Loesche (a,b : Integer; R : in out Relation); 

   type Paar is record 
      a,b: Integer; 
   end record;
   
   type PaarArray is array (Integer range <>) of Paar;
   
   -- Trgt alle Paare in die Relation R ein. 
   procedure Eintragen (Paare : PaarArray; M : in out Relation);

   -- Prft, ob das Paar (a,b) in R liegt.
   function LiegtIn (a,b : Integer; R : Relation) return Boolean; 

--   -- Prft, ob eine Relation R leer ist.
--   function IstLeer (R : Relation) return Boolean; 

   -- Konverse Relation zu R.
   function transponiere(R : Relation) return Relation;

   -- Bildet die Vereinigungsmenge zweier Relationen.
   function "+" (R1, R2 : Relation) return Relation; 

   -- Bildet das Produkt zweier Relationen.
   function "*" (R1, R2 : Relation) return Relation; 

   -- Kleinstes Element der Grundmenge.
   function von (R : Relation) return Integer; 

   -- Grtes Element der Grundmenge.
   function bis (R : Relation) return Integer; 

   -- Bildet die transitive Hlle einer Relation.
   function Warshall (R : Relation) return Relation; 
   
   -- Nimmt Elemente von R2 zu R1 hinzu.
   procedure Hinzu (R1 : in out Relation; R2 : Relation); 
 
   -- Entfernt die Elemente von R2 aus R1.
   procedure Hinweg (R1 : in out Relation; R2 : Relation);
   
   -- Druckt R.
   procedure Drucke (R : Relation; 
                     Text : in String := "Adjazenzmatrix:");
   
private

   type Relation_Rec;
   
   type Relation is access Relation_Rec;
   
end Relationen;